function refreshStatus($id, $source) {
    fetch($source)
    .then( (response) => response.text() )
    .then( (text) => {
        document.getElementById($id).innerText = text;
    });
}

function refreshHTML($id, $source) {
    fetch($source)
    .then( (response) => response.text() )
    .then( (text) => {
        document.getElementById($id).innerHTML = text;
    });
}

function setupRefreshStatus($id, $source, $interval) {
    refreshStatus($id, $source);
    setInterval( function () { refreshStatus($id, $source); }, $interval );
}

function setupRefreshHTML($id, $source, $interval) {
    refreshHTML($id, $source);
    setInterval( function () { refreshHTML($id, $source); }, $interval );
}

function sendCallback($callback, $key, $value) {
    var $body = encodeURIComponent($key)+"="+encodeURIComponent($value);
    fetch($callback, {
        method: "post", 
        headers: {"Content-Type": "application/x-www-form-urlencoded"},
        body: $body
    } );
}

function handleCheckboxChange($id, $callback) {
    var $state = document.getElementById($id).checked;
    sendCallback($callback, $id, $state?"1":"0");
}

function handleChange($id, $callback) {
    var $state = document.getElementById($id).value;
    sendCallback($callback, $id, $state);
}

function reloadContent($id, $source) {
    fetch($source)
    .then( (response) => response.text() )
    .then( (text) => {
        var $elem = document.getElementById($id);
        $elem.value = text;
        if ( $elem.onchange != null ) {
            $elem.onchange();
        }
    });
}
